# File: Meeting.py
"""
Meeting: used to display meeting information and reference meeting documents
"""
# Copyright (c) 2005,2006 by Alteroo Consulting Group
#
# Generated: Sat Jul 30 00:47:54 2005
# Generator: ArchGenXML Version 1.2 beta 1 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Andre Brown <andre.brown@alteroo.com>, David Bain <david@alteroo.com>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo

security = ClassSecurityInfo()
#lingua plone support
try:
    from Products.LinguaPlone.public import *
except:
    #no multilingual support
    from Products.Archetypes.public import *

#get the getToolByName thingy
from Products.CMFCore.utils import getToolByName

#Attachment field support  not in use 
#from Products.AttachmentField.AttachmentField import AttachmentField
#from Products.AttachmentField.AttachmentWidget import AttachmentWidget

#Reference browser support
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import ReferenceBrowserWidget
# Import meeting interface
from Products.Meeting.interfaces import IMeetingBase #, IMeetingConferencepapers
##code-section module-header #fill in your manual code here

## Using ATContent schema adds Plone 2.1 features such as the Display menu to the Product
from Products.ATContentTypes.content.document import ATDocument
from Products.ATContentTypes.configuration import zconf
from Products.ATContentTypes.content.document import finalizeATCTSchema
from Products.CMFPlone.interfaces.NonStructuralFolder import INonStructuralFolder
from Products.ATContentTypes.content.base import updateActions

#for calendar support
from Products.ATContentTypes.lib.calendarsupport import CalendarSupportMixin
from Products.ATContentTypes.permission import ChangeEvents

# Added CountryWidget Support
from Products.ATCountryWidget.Widget import CountryWidget, AreaWidget

#get Attachments manager widget
from Products.Meeting.widgets import AttachmentsManagerWidget

#get References  manager widget
from Products.Meeting.widgets import ReferencesManagerWidget

#grab stuff from AttachmentMixin may be more than I need
from Products.PloneArticle.AttachmentMixin import methodGenerator, registerAttachmentSchema, AttachmentReferenceBrain, OrderedList
from Products.PloneArticle.AttachmentMixin import AttachmentContents as BaseAttachmentContents


#this is needed in order to define the attachments
from Products.PloneArticle.ArticleCore import ArticleReferenceBrain

from Products.Meeting.PloneArticleFunctions import PloneArticleFunctions

from Products.PloneArticle.ArticleCore import ArticleContents as BaseArticleContents

#subclass ArticleContents in order to over it
class ArticleContents(BaseArticleContents):

    security.declarePrivate('getContentType')
    def getContentType(self, instance):
        """
        Returns portal type to add.
        We use the portal_article tool parameters to find what content types
        we might add for this content, and we use article class instance as a workaround
        if we cannot find the right type.
        """
        # Normal handling for regular PA types
        portal_article = getToolByName(instance, 'portal_article')
        if self.name == 'image':
            return portal_article.getAllowedImageType()
        elif self.name == 'workingdoc':
            return portal_article.getAllowedAttachmentType()
        elif self.name == 'informationdoc':
            return portal_article.getAllowedAttachmentType()
        elif self.name == 'referencedoc':
            return portal_article.getAllowedAttachmentType()
        elif self.name == 'presentation':
            return portal_article.getAllowedAttachmentType()
        elif self.name == 'attachment':
            return portal_article.getAllowedAttachmentType()
        elif self.name == 'conferencepaper':
            return portal_article.getAllowedAttachmentType()
        elif self.name == 'presentation':
            return portal_article.getAllowedAttachmentType()
        elif self.name == 'link':
            return portal_article.getAllowedLinkType()


    security.declarePrivate('getAllowedContentTypes')
    def getAllowedContentTypes(self, instance): 
        """
        Returns portal types you can paste as reference
        """
        portal_article = getToolByName(instance, 'portal_article')
        if self.name == 'image':
            return portal_article.getAllowedImageTypes()
        elif self.name == 'attachment':
            return portal_article.getAllowedAttachmentTypes()
        elif self.name == 'workingdoc':
            return portal_article.getAllowedAttachmentTypes()
        elif self.name == 'informationdoc':
            return portal_article.getAllowedAttachmentType()
        elif self.name == 'referencedoc':
            return portal_article.getAllowedAttachmentType()
        elif self.name == 'presentation':
            return portal_article.getAllowedAttachmentTypes()
        elif self.name == 'conferencepaper':
            return portal_article.getAllowedAttachmentTypes()
        elif self.name == 'link':
            return portal_article.getAllowedLinkTypes()
        else:
            raise NotImplementedError, "Don't know how to handle '%s' types." % (self.name,)


##/code-section module-header

from schemata import base_meetingschema

class Meeting(ATDocument, ArticleContents, CalendarSupportMixin, OrderedBaseFolder, PloneArticleFunctions):
    """Meeting: used to display meeting information and meeting documents"""

    security = ClassSecurityInfo()
    portal_type = meta_type = 'Meeting' 
    archetype_name = 'Meeting'   #this name appears in the 'add' box 
    allowed_content_types = [] 
# Implement ATDocument
    __implements__ = ATDocument.__implements__ + CalendarSupportMixin.__implements__ + (IMeetingBase,
# IMeetingConferencepapers,
 INonStructuralFolder)
    
    
    # define the meeting attachments
    # THIS CODE IS BIG
    meeting_attachments = (
             ArticleContents('attachment'),
             ArticleContents('workingdoc'),
             ArticleContents('informationdoc'),
             ArticleContents('referencedoc'),
             ArticleContents('conferencepaper'), #DON'T PLURALIZE. IT WILL MESS UP THE AUTOGENERATION CODE
             ArticleContents('presentation'), #DON'T PLURALIZE. IT WILL MESS UP THE AUTOGENERATION CODE
                  )

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header
    ##override of base schema for meeting customizations
    MeetingBase = ATDocument.schema.copy() 
    MeetingBase['id'].widget.visible = {'View':'invisible',
                                        'edit':'invisible'}
    MeetingBase['title'].widget.label='Name'
#    MeetingBase['title'].schemata="Meeting Details"
    MeetingBase['title'].widget.description='The name of the meeting'
#    MeetingBase['title'].languageIndependent=1


    security.declarePublic("getCountryName")
    def getCountryName(self,value=''):
        """ get the country by name """
        ctool = getToolByName(self, 'portal_countryutils')
        countryname = ctool.getCountryByIsoCode(self.getCountry()).name
        return countryname

    security.declarePublic("setFullLocation")
    def setFullLocation(self,value=''):
        """ combine country and theLocation to generate location """
        location = "%s,%s" % (self.getCountryName(),self.getTheLocation())
        self.getField('location').set(self,location)
      
    security.declarePublic("getLocation")
    def getLocation(self,value=''):
        """ combine country and theLocation to generate location """
        location = "%s,%s" % (self.getCountryName(),self.getTheLocation())
        return location

    security.declarePublic("getAllowedAttachmentTypes")
    def getAllowedAttachmentTypes(self):
        """
        Get allowed attachment types - borrowed from PloneArticle
        """
        tool = getToolByName(self, 'portal_article')
        return tool.allowed_attachment_types

    security.declarePublic("getAllowedAttachmentType")
    def getAllowedAttachmentType(self):
        """
        Get allowed attachment type - borrowed from PloneArticle
        """
        tool = getToolByName(self, 'portal_article')
        return tool.allowed_attachment_type

    security.declarePublic("getAllowedPresentationTypes")
    def getAllowedPresentationTypes(self):
        """
        Get allowed presentation types based on allowed attachment types - borrowed from PloneArticle
        """
        tool = getToolByName(self, 'portal_article')
        return tool.allowed_attachment_types

    security.declarePublic("getAllowedPresentationType")
    def getAllowedPresentationType(self):
        """
        Get allowed presentation type based on allowed attachment type - borrowed from PloneArticle
        """
        tool = getToolByName(self, 'portal_article')
        return tool.allowed_attachment_type

    # ------------------------------------------------------------------------------
    security.declarePublic("getAllowedConferencepaperType")
    def getAllowedConferencepaperType(self):
        """
        Get allowed conference paper type based on allowed attachment type - borrowed from PloneArticle
        """
        tool = getToolByName(self, 'portal_article')
        return tool.allowed_attachment_type

    security.declarePublic("getAllowedConferencepaperTypes")
    def getAllowedConferencepaperTypes(self):
        """
        Get allowed presentation types based on allowed attachment types - borrowed from PloneArticle
        """
        tool = getToolByName(self, 'portal_article')
        return tool.allowed_attachment_types

    # --------------------------------------------------------------------------
    security.declarePublic("getAllowedWorkingdocType")
    def getAllowedWorkingdocType(self):
        """
        Get allowed conference paper type based on allowed attachment type - borrowed from PloneArticle
        """
        tool = getToolByName(self, 'portal_article')
        return tool.allowed_attachment_type

    security.declarePublic("getAllowedWorkingdocTypes")
    def getAllowedAllowedWorkingdocTypes(self):
        """
        Get allowed presentation types based on allowed attachment types - borrowed from PloneArticle
        """
        tool = getToolByName(self, 'portal_article')
        return tool.allowed_attachment_types

    # -----------------------------------------------------------------------------
    security.declarePublic("getAllowedInformationdocType")
    def getAllowedInformationdocType(self):
        """
        Get allowed information doc type based on allowed attachment type - borrowed from PloneArticle
        """
        tool = getToolByName(self, 'portal_article')
        return tool.allowed_attachment_type

    security.declarePublic("getAllowedInformationdocTypes")
    def getAllowedInformationdocTypes(self):
        """
        Get allowed information doc types based on allowed attachment types - borrowed from PloneArticle
        """
        tool = getToolByName(self, 'portal_article')
        return tool.allowed_attachment_types



    security.declarePublic("getAllowedReferencedocType")
    def getAllowedReferencedocType(self):
        """
        Get allowed reference paper type based on allowed attachment type - borrowed from PloneArticle
        """
        tool = getToolByName(self, 'portal_article')
        return tool.allowed_attachment_type

    security.declarePublic("getAllowedReferencedocTypes")
    def getAllowedReferencedocTypes(self):
        """
        Get allowed reference types based on allowed attachment types - borrowed from PloneArticle
        """
        tool = getToolByName(self, 'portal_article')
        return tool.allowed_attachment_types




    security.declarePrivate('generateMoreMethods')
    def generateMoreMethods(self, Meeting):
        """
        Generates dynamic methods
        """

        name = self.name.capitalize()

        generate_methods = (
            ('getAllowed%sType', 'getAllowedPresentationType', self._view_permission),
            ('getAllowed%sTypes', 'getAllowedPresentationTypes', self._view_permission),
            )

        for gen_method in generate_methods:
            to_method = gen_method[0] % name
            from_method = gen_method[1]
            permission = gen_method[2]
            methodGenerator().make(self, klass, from_method, to_method, permission)


    
    meeting_schema=MeetingBase +  base_meetingschema

# Finialize the schema according to the ATContentTypes standrards.

    finalizeATCTSchema(meeting_schema)
    meeting_schema['id'].widget.visible = {'View':'invisible',
                                        'edit':'invisible'}
    meeting_schema['title'].widget.label='Name'
#    MeetingBase['title'].schemata="Meeting Details"
    meeting_schema['title'].widget.description='The name of the meeting'
#    meeting_schema['title'].languageIndependent=1
    
    schema=meeting_schema
    #Methods

    #Method overides of PloneArticle.AttachmentMixin.ArticleContent

    security.declarePrivate('addContentFromObject')
    def addContentFromObject(self, instance, content):
        """
        Attach a content to instance. Just add a reference between content and
        instance.
        
        Parameters
            attachment -> content object to attach
        """
        
        content_type = content.portal_type
        allowed_content_type = self.getAllowedContentTypes(instance)
        
        if content_type not in allowed_content_type:
            Log(LOG_NOTICE, "Wrong attachment type. Expected : %s, given %s." % (allowed_content_type, content_type))
            raise TypeError, "%s cannot be added as %s. Use %s type" % (content_type, self.name, allowed_content_type)
        
        # Create brain
        brain = self._brain_klass(content.Title(), content.Description())
        
        # Add reference
        ref = instance.addReference(content, self.getRelationShip())
        setattr(ref, self._content_brain_id, brain)
        brain.__of__(ref)
        
        # Append ref UID to an ordered list
        self.getOrderedRefsList(instance).add([ref.UID()])
        
        # Reindex instance
        instance.reindexObject()
    
    security.declarePrivate('addContentFromUID')
    def addContentFromUID(self, instance, UID):
        """
        Attach a content to instance. Just add a reference between content and
        instance.
        
        Parameters
            UID -> UID of a content to attach
        """
        
        # Get object from UID and add content reference
        content = self.getContent(instance, UID)
        self.addContentFromObject(instance, content)
    # uncomment lines below when you need
   # factory_type_information={
    #    'allowed_content_types':allowed_content_types,
    #    'allow_discussion': 0,
    #    #'content_icon':'Meeting.gif',
    #    'immediate_view':'base_view',
    #    'global_allow':1,
    #    'filter_content_types':1,
    #    }
    content_icon = 'meeting.gif'
    default_view = 'meeting_view'
    immediate_view = 'meeting_view'
    #suppl_views = ('meeting_view_preview',)
    typeDescription= 'Meeting: used to display meeting information and meeting documents'
    typeDescMsgId  = 'description_edit_meeting'


    meeting_actions = (
        {
        'id'          : 'registration_documents',
        'name'        : 'Registration Form',
        'action'      : 'string:${object_url}/atct_edit?fieldset=Registration',
        #'permissions' : (ATCTPermissions.ViewHistory, ),
        #'visible' : False,
         },
        {
        'id'          : 'meeting_documents',
        'name'        : 'Meeting Documents',
        'action'      : 'string:${object_url}/meeting_documents_form',
        #'permissions' : (ATCTPermissions.ViewHistory, ),
        #'visible' : False,
         },
           {
          'id'          : 'presentation',
          'name'        : 'Presentations',
          'action'      : 'string:${object_url}/meeting_presentations_form',
          'condition'   : 'python:not object.hasLockSupport() or object.canToggleLock()',
          #'permissions' : (Permissions.EditPloneArticle,),
          'visible'     : 0,
         },
           {
          'id'          : 'attach',
          'name'        : 'Attachments',
          'action'      : 'string:${object_url}/meeting_documents_form',
          #'condition'   : 'python:not object.hasLockSupport() or object.canToggleLock()',
          #'permissions' : (Permissions.EditPloneArticle,),
          'visible'     : 0,
         },

        {
        'id'          : 'hotel_visa',
        'name'        : 'Hotel/Accomodation',
        'action'      : 'string:${object_url}/atct_edit?fieldset=Hotel%20Visa',
        #'permissions' : (ATCTPermissions.ViewHistory, ),
        #'visible' : False,
         },
       )
   
    #actions = updateActions(ATDocument.actions,
    #                        meeting_actions
    #                       )
 
    actions= ATDocument.actions +  CalendarSupportMixin.actions + meeting_actions
        


##code-section module-footer #fill in your manual code here
##/code-section module-footer


        
registerType(Meeting)
# end of class Meeting

# register the meeting attachments (for PloneArticle)
registerAttachmentSchema(Meeting,'meeting_attachments') 
