#lingua plone support
try:
    from Products.LinguaPlone.public import *
except:
    #no multilingual support
    from Products.Archetypes.public import *

#for calendar support
from Products.ATContentTypes.lib.calendarsupport import CalendarSupportMixin
from Products.ATContentTypes.permission import ChangeEvents

## Using ATContent schema adds Plone 2.1 features such as the Display menu to the Product
from Products.ATContentTypes.content.document import ATDocument
from Products.ATContentTypes.configuration import zconf

# Added CountryWidget Support
from Products.ATCountryWidget.Widget import CountryWidget, AreaWidget

#get Attachments manager widget # no longer in use
#from Products.Meeting.widgets import AttachmentsManagerWidget


#get References  manager widget
#from Products.Meeting.widgets import ReferencesManagerWidget

#Reference browser support
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import ReferenceBrowserWidget


base_meetingschema = Schema((
       
        StringField('meetingType',
                    searchable=1,
                    #schemata="Meeting Details",
                    languageIndependent=1,
                    index='FieldIndex',
            vocabulary=["CEP - IGM", "CEP - MONCOM", "SPAW - ISTAC", "SPAW - Workshop", "SPAW - COP", "SPAW - STAC", "LBS - ISTAC", "LBS - Workshop"],
            widget=SelectionWidget(label='Meeting Type',
             ),
        ),
        
        DateTimeField('start',
                    searchable=1,
                    #schemata="Meeting Details",
                    write_permission = ChangeEvents,
                    languageIndependent=1,
                    index='DateIndex',
  widget = CalendarWidget(
                description='''Meeting start date and time''',
                description_msgid = "help_event_start",
                label = "Start",
                label_msgid = "label_event_start",
                format='%d.%m.%Y',
                i18n_domain='plone',
                languageIndependent=1,

            ),
        ),
        
        DateTimeField('end',
                    searchable=1,
                    #schemata="Meeting Details",
                    write_permission = ChangeEvents,
                    languageIndependent=1,
            widget=CalendarWidget(description='''Meeting end date and time''',
                description_msgid = "help_event_end",
                i18n_domain='plone',
                label='End',
                label_msgid = "label_event_end",
                format='%d.%m.%Y',
                languageIndependent=1,
            ),
        ),
 TextField('text',
              required=0,
              searchable=True,
              primary=True,
              storage = AnnotationStorage(migrate=True),
              validators = ('isTidyHtmlWithCleanup',),
              #validators = ('isTidyHtml',),
              default_content_type = zconf.ATDocument.default_content_type,
              default_output_type = 'text/x-html-safe',
              allowable_content_types = zconf.ATDocument.allowed_content_types,
              widget = RichWidget(
                        description = "add details about the meeting here",
                        description_msgid = "announcement_description",
                        label = "Announcement",
                        label_msgid = "announcement",
                        rows = 25,
                        i18n_domain = "plone",
                        allow_file_upload = zconf.ATDocument.allow_document_upload
                    ),
                   ),

        TextField('country',
                    index='FieldIndex:brains',
                    #schemata="Meeting Details",
                    languageIndependent=1,
widget=CountryWidget(
            description='''Country where the meeting will be held''',
                description_msgid='Meeting_help_country',
                i18n_domain='meeting',
                label='Country',
                label_msgid='Meeting_label_country',
            ),
        ),
        StringField('theLocation',
                    index='FieldIndex:brains',
                    #schemata="Meeting Details",
widget=StringWidget(
            description='''
Use this to specify a more specific location (this could be something like: Hilton Hotel, Kingston)''',
                description_msgid='Meeting_help_Location',
                i18n_domain='meeting',
                label='Location',
                label_msgid='Meeting_label_Location',
            ),
        ),



    StringField('location',
                index='FieldIndex:brains',
                    languageIndependent=1,
widget=StringWidget(
                visible={'view':'hidden','edit':'hidden'},
                searchable=True,
                mutator='setFullLocation',
                write_permission = ChangeEvents,
                    description = "",
                    description_msgid = "help_event_location",
                    label = "Event Location",
                    label_msgid = "label_event_location",
                    i18n_domain = "plone",
        ),
   ),

        
        TextField('description',
                    searchable=1,
                    #schemata="Meeting Details",
                    #languageIndependent=1,
            widget=TextAreaWidget(description='''Put a short description of the meeting. This will show up in search results''',
                description_msgid='Meeting_summary_Details',
                i18n_domain='meeting',
                label='Summary',
                label_msgid='Meeting_summary_label_Details',
            ),
        ),

       # disabled cuz it AIN't Working properly 
       # BooleanField('referencedrecommendedstuff',
       #     default=True,
       #     languageIndependent=1,
       #     allowed_types=('Meeting Document',),
       #     widget=ReferencesManagerWidget(
       #         description="If selected, a list of uploaded attachments will be "
       #                      "presented at the bottom of the document to allow "
       #                      "them to be easily downloaded",
       #         description_msgid='RichDocument_help_displayAttachments',
       #         i18n_domain='RichDocument',
       #         label="""Display attachments download box""",
       #         label_msgid='RichDocument_label_displayAttachments',
       #     ),
       # ),


            TextField('HotelAndVisa',
            index='FieldIndex:brains',
            searchable=1,
            schemata="Hotel Visa",
            #needed to define output type and content to properly support rich editing
            default_content_type = zconf.ATDocument.default_content_type,
            default_output_type = 'text/x-html-safe',
            #languageIndependent=1,
            widget=RichWidget(description='''Miscellaneous information on accomodations and visa requirements''',
                description_msgid='Meeting_help_Hotel',
               i18n_domain='meeting',
                label='''Hotel and Visa Information''',
                label_msgid='label_hotel_information',
            ),
        ),
   StringField('Registration',
            searchable=1,
            schemata="Registration",
            allowed_types=('Document','File'),
            relationship="registration_form",
            widget=ReferenceBrowserWidget(description='''attach a downloadable registration form''',
                description_msgid='description_registration_form',
                i18n_domain='meeting',
               label='''Registration Form''',
                label_msgid='label_registration_form',
            )
        ),
    ), marshall=RFC822Marshaller()
    )
