## Controller Python Script "plonearticle_uid_reference"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=uid, type
##title=Add object of type to article as references

# define the charset : useful for utf-8 sites using translate.py (see for something smarter)
from Products.CMFCore.utils import getToolByName
charset = getToolByName(context, 'portal_properties')['site_properties'].default_charset
context.REQUEST.RESPONSE.setHeader('Content-Type','text/html; charset=%s'%charset)

message = ''
state.setNextAction('redirect_to_action:string:view')

if type == 'image':
    try:
        context.addImageFromUID(uid)
        message = context.translate(
              domain='plonearticle', msgid='message_image_pasted',
              mapping={}, 
              default = 'Image(s) pasted.'
            )
    except:
        message = context.translate(
            domain='plonearticle', msgid='message_paste_image_error',
            mapping={'error_count': 1, 'image_count': 1},
            default = 'You tried to paste %s image(s). Unauthorized content type used for %s image(s).'%(1, 1)
          )
    state.setNextAction('redirect_to_action:string:image')

elif type == 'attachment':
    #context.addAttachmentFromUID(uid)
    try:
        context.addAttachmentFromUID(uid)
        message = context.translate(
              domain='plonearticle', msgid='message_attachment_pasted',
              mapping={}, 
              default = 'Attachment(s) pasted.'
            )
    except:
        message = context.translate(
            domain='plonearticle', msgid='message_paste_attachment_error',
            mapping={'error_count': 1, 'attachment_count': 1},
            default = 'You tried to paste %s attachments(s). Unauthorized content type used for %s attachment(s).'%(1, 1)
          )
    state.setNextAction('redirect_to_action:string:meeting_documents')

elif type == 'workingdoc':
    try:
        context.addWorkingdocFromUID(uid)
        message = context.translate(
              domain='plonearticle', msgid='message_workingdoc_pasted',
              mapping={}, 
              default = 'Working Document(s) pasted.'
            )
    except:
        message = context.translate(
            domain='plonearticle', msgid='message_paste_attachment_error',
            mapping={'error_count': 1, 'attachment_count': 1},
            default = 'You tried to paste %s working document(s). Unauthorized content type used for %s working document(s).'%(1, 1)
          )
    state.setNextAction('redirect_to_action:string:meeting_documents')

elif type == 'informationdoc':
    try:
        context.addInformationdocFromUID(uid)
        message = context.translate(
              domain='plonearticle', msgid='message_informationdoc_pasted',
              mapping={}, 
              default = 'Information Document(s) pasted.'
            )
    except:
        message = context.translate(
            domain='plonearticle', msgid='message_paste_attachment_error',
            mapping={'error_count': 1, 'attachment_count': 1},
            default = 'You tried to paste %s information document(s). Unauthorized content type used for %s information document(s).'%(1, 1)
          )
    state.setNextAction('redirect_to_action:string:meeting_documents')

elif type == 'referencedoc':
    try:
        context.addReferencedocFromUID(uid)
        message = context.translate(
              domain='plonearticle', msgid='message_referencedoc_pasted',
              mapping={}, 
              default = 'Reference Document(s) pasted.'
            )
    except:
        message = context.translate(
            domain='plonearticle', msgid='message_paste_attachment_error',
            mapping={'error_count': 1, 'attachment_count': 1},
            default = 'You tried to paste %s reference document(s). Unauthorized content type used for %s reference document(s).'%(1, 1)
          )
    state.setNextAction('redirect_to_action:string:meeting_documents')

elif type == 'conferencepaper':
    try:
        context.addConferencepaperFromUID(uid)
        message = context.translate(
              domain='plonearticle', msgid='message_attachment_pasted',
              mapping={}, 
              default = 'Conference Room Paper(s) pasted.'
            )
    except:
        message = context.translate(
            domain='plonearticle', msgid='message_paste_attachment_error',
            mapping={'error_count': 1, 'attachment_count': 1},
            default = 'You tried to paste %s conference room paper(s). Unauthorized content type used for %s conference room paper(s).'%(1, 1)
          )
    state.setNextAction('redirect_to_action:string:meeting_documents')

elif type == 'presentation':
    #context.addPresentationFromUID(uid)
    try:
        context.addPresentationFromUID(uid)
        message = context.translate(
              domain='plonearticle', msgid='message_presentation_pasted',
              mapping={}, 
              default = 'Presentation(s) pasted.'
            )
    except:
        message = context.translate(
            domain='plonearticle', msgid='message_paste_attachment_error',
            mapping={'error_count': 1, 'presentation_count': 1},
            default = 'You tried to paste %s presentation(s). Unauthorized content type used for %s presentation(s).'%(1, 1)
          )
    state.setNextAction('redirect_to_action:string:meeting_documents')
elif type == 'link':
    try:
        context.addLinkFromUID(uid)
        message = context.translate(
              domain='plonearticle', msgid='message_link_pasted',
              mapping={}, 
              default = 'Link(s) pasted.'
            )
    except:
        message = context.translate(
            domain='plonearticle', msgid='message_paste_link_error',
            mapping={'error_count': 1, 'link_count': 1},
            default = 'You tried to paste %s link(s). Unauthorized content type used for %s link(s).'%(1, 1)
          )
    state.setNextAction('redirect_to_action:string:link')

return state.set(status='success',\
                 context=context,\
                 portal_status_message=message)
