## Controller Python Script "widget_referencesmanager_upload"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=id='',title='', referenceTitle=None, referenceFile
##title=Upload a new reference
##

from Products.CMFCore.utils import getToolByName

plone_utils = getToolByName(context, 'plone_utils')

def findUniqueId(id):
    contextIds = context.objectIds()

    if id not in contextIds:
        return id

    dotDelimited = id.split('.')

    ext = dotDelimited[-1]
    name = '.'.join(dotDelimited[:-1])

    idx = 0
    while(name + '.' + str(idx) + '.' + ext) in contextIds:
        ++idx

    return(name + '.' + str(idx) + '.' + ext)


# Move object out of portal factory if necessary. We can't create images inside
# a folder in the portal factory
new_context = context.portal_factory.doCreate(context, id)

status = 'failure'
message = "You must select an reference to upload"

if referenceFile:

    # Make sure we have a unique file name
    fileName = referenceFile.filename

    imageId = ''

    if fileName:
        fileName = fileName.split('/')[-1]
        fileName = fileName.split('\\')[-1]
        fileName = fileName.split(':')[-1]

        imageId = plone_utils.normalizeString(fileName)

    if not imageId:
        imageId = plone_utils.normalizeString(referenceTitle)

    imageId = findUniqueId(imageId)

    newImageId = new_context.invokeFactory(id = imageId, type_name = 'FileAttachment')
    if newImageId is not None and newImageId != '':
        imageId = newImageId

    object = getattr(new_context, imageId, None)
    object.setTitle(referenceTitle)
    object.setFile(referenceFile)
    object.reindexObject()
    status = 'success'
    message = "Reference added"

return state.set(context = new_context,
                  status = status,
                  portal_status_message = message)
